//------------------------------------------------------
//
//   Greg's Blocks Mod - Main
//
//------------------------------------------------------

package gcewing.blocks;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Map;
import java.util.Hashtable;

import net.minecraft.block.*;
import net.minecraft.entity.player.*;
import net.minecraft.item.*;
import net.minecraft.world.*;

import net.minecraftforge.common.*;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.network.*;
import cpw.mods.fml.common.registry.*;

@Mod(modid=Info.modID, name=Info.modName , version=Info.versionNumber)

@NetworkMod(clientSideRequired=true, serverSideRequired=false, versionBounds = Info.versionBounds,
	channels={PacketHandler.channelName}, packetHandler = PacketHandler.class)

public class GregsBlocks extends BaseMod {

	//@Mod.Instance("GregsBlocks")
	public static GregsBlocks mod;

	//@SidedProxy(clientSide="gcewing.blocks.ProxyClient", serverSide="gcewing.blocks.Proxy")
	//public static Proxy proxy;
	
	public static String modName = "GregsBlocks";
	public final static String textureDir = "/gcewing/blocks/resources/";
	public final static String textureFile = textureDir + "textures.png";
	
	static String configName = modName + ".cfg";
	static File cfgfile;
	static Map <Integer, String> idToBlockName = new Hashtable <Integer, String>();
	static Map <Integer, String> idToItemName = new Hashtable <Integer, String>();
	static int nextBlockID = 1, nextItemID = 1;
	static boolean autoAssign;
	
//	public static boolean isServer;
	
	//
	//   Blocks and Items
	//
	
	public static BlockSawbench blockSawbench;
	public static Block blockShape;

	public static Item itemSawblade;
	public static Item itemLargePulley;
	public static Item itemChisel;
	
	public GregsBlocks() {
		super();
		mod = this;
	}
	
	@Mod.PreInit
	public void preInit(FMLPreInitializationEvent e) {
		super.preInit(e);
	}

	@Mod.Init
	public void init(FMLInitializationEvent e) {
		super.init(e);
	}
	
	BaseModClient initClient() {
		return new GregsBlocksClient(this);
	}

	@Mod.PostInit
	public void postInit(FMLPostInitializationEvent e) {
		super.postInit(e);
	}

//	void loadConfig() {
//		config = new OrderedProperties();
//		try {
//			config.load(new FileInputStream(cfgfile));
//		}
//		catch (FileNotFoundException e) {
//			System.out.printf("%s: No existing config file\n", modName);
//		}
//		catch (IOException e) {
//			System.out.printf("%s: Failed to read %s\n%s\n", modName,
//				cfgfile.getPath(), e);
//		}
//		autoAssign = getConfigBool("autoAssign", false);
//		//System.out.printf("%s: autoAssign = %s\n", modName, autoAssign);
//		config.extended = false;
//	}
	
//	void saveConfig() {
//		try {
//			if (autoAssign || config.extended) {
//				putConfigBool("autoAssign", false);
//				System.out.printf("%s: Writing config file\n", modName);
//				config.store(new FileOutputStream(cfgfile),
//					modName + " Configuration File");
//			}
//		}
//		catch (IOException e) {
//			System.out.printf("%s: Failed to %s\n%s\n", modName,
//				cfgfile.getPath(), e);
//		}
//	}
	
	void registerBlocks() {
		//blockSawbench = new BlockSawbench(getBlockID(1040, "sawbench"));
		blockSawbench = newBlock("sawbench", BlockSawbench.class, "Sawbench");
		blockSawbench.setHardness(2.0F);
		//addBlock("Sawbench", blockSawbench);
		//blockShape = addBlock("Shaped Block", new BlockShape(getBlockID(1041, "shape")), ItemShape.class);
		blockShape = newBlock("shape", BlockShape.class, ItemShape.class, "Shaped Block");
	}
	
	void registerTileEntities() {
		GameRegistry.registerTileEntity(TESawbench.class, "gcewing.sawbench");
		GameRegistry.registerTileEntity(TEShape.class, "gcewing.shape");
	}
	
	void registerItems() {
		//itemSawblade = addItem("Circular Saw Blade", newItemI(10400, "sawblade", 0x12));
		itemSawblade = newItem("sawblade", "Circular Saw Blade");
		//itemLargePulley = addItem("Large Pulley", newItemI(10401, "largePulley", 0x13));
		itemLargePulley = newItem("largePulley", "Large Pulley");
		//itemChisel = addItem("Chisel", new ItemChisel(getItemID(10402, "chisel")).setIconIndex(0x14));
		itemChisel = newItem("chisel", ItemChisel.class, "Chisel");
	}

	void registerRecipes() {
		newRecipe(blockSawbench, 1, "IsI", "WWP", "WWp",
			'I', Item.ingotIron, 's', itemSawblade, 'W', Block.planks, 'p', Block.pressurePlatePlanks,
			'P', itemLargePulley);
		newRecipe(itemSawblade, 1, " I ", "IsI", " I ",
			'I', Item.ingotIron, 's', Item.stick);
		newRecipe(itemLargePulley, 1, " W ", "WsW", " W ",
			'W', Block.planks, 's', Item.stick);
		newRecipe(itemChisel, 1, "I", "s",
			'I', Item.ingotIron, 's', Item.stick);
}
	
//	void addRecipe(Item product, int qty, Object... params) {
//		GameRegistry.addRecipe(new ItemStack(product, qty), params);
//	}
//
//	void addRecipe(Block product, int qty, Object... params) {
//		GameRegistry.addRecipe(new ItemStack(product, qty), params);
//	}
//
//	void addShapelessRecipe(Item product, int qty, Object... params) {
//		GameRegistry.addShapelessRecipe(new ItemStack(product, qty), params);
//	}
//
//	void addSmeltingRecipe(Item product, int qty, Item input) {
//		GameRegistry.addSmelting(input.shiftedIndex, new ItemStack(product, qty), 0);
//	}
//	
//	void addSmeltingRecipe(Item product, int qty, Block input) {
//		GameRegistry.addSmelting(input.blockID, new ItemStack(product, qty), 0);
//	}
//	
//	static int getBlockID(int defaultID, String name) {
//		if (autoAssign)
//			defaultID = nextUnusedBlockID();
//		return getBlockOrItemID(defaultID, "tile.", name, idToBlockName);
//	}
//	
//	static int getItemID(int defaultID, String name) {
//		if (autoAssign)
//			defaultID = nextUnusedItemID();
//		return getBlockOrItemID(defaultID, "item.", name, idToItemName);
//	}
//	
//	static int getBlockOrItemID(int defaultID, String prefix, String name, 
//			Map <Integer, String> idToName)
//	{
//		String qualName = "gcewing." + name;
//		String key = prefix + qualName + ".id";
//		int id;
//		if (config.containsKey(key)) {
//			String value = (String) config.get(key);
//			id = Integer.parseInt(value);
//		}
//		else {
//			config.put(key, Integer.toString(defaultID));
//			id = defaultID;
//		}
//		idToName.put(Integer.valueOf(id), qualName);
//		return id;
//	}
//	
//	static int nextUnusedBlockID() {
//		//System.out.printf("%s: nextUnusedBlockID\n", modName);
//		while (nextBlockID < 4096) {
//			if (Block.blocksList[nextBlockID] == null)
//				return nextBlockID;
//			nextBlockID += 1;
//		}
//		throw new RuntimeException(modName + ": Out of block IDs");
//	}
//	
//	static int nextUnusedItemID() {
//		//System.out.printf("%s: nextUnusedItemID\n", modName);
//		while (nextItemID < 32768) {
//			if (Item.itemsList[nextItemID + 256] == null)
//				return nextItemID;
//			nextItemID += 1;
//		}
//		throw new RuntimeException(modName + ": Out of item IDs");
//	}
//	
//	boolean getConfigBool(String key, boolean defaultValue) {
//		if (config.containsKey(key))
//			return ((String)config.get(key)).equals("true");
//		else {
//			putConfigBool(key, defaultValue);
//			return defaultValue;
//		}
//	}
//	
//	void putConfigBool(String key, boolean value) {
//		config.put(key, value ? "true" : "false");
//	}
//
//	Item newItem(int id, String name) {
//		return customItem(getItemID(id, name));
//	}
//	
//	Item newItemI(int id, String name, int icon) {
//		return customItem(getItemID(id, name)).setIconIndex(icon);
//	}
//	
//	Item newItemSI(int id, String name, int maxStack, int icon) {
//		return customItem(getItemID(id, name)).setMaxStackSize(maxStack).setIconIndex(icon);
//	}
//	
//	Item customItem(int id) {
//		return new TexturedItem(id);
//	}
//		
//	Block addBlock(String title, Block block) {
//		return addBlock(title, block, ItemBlock.class);
//	}
//
//	Block addBlock(String title, Block block, Class itemClass) {
//		//System.out.printf("%s: Adding block %s id %s\n", modName, title, block.blockID);
//		block.setBlockName(idToBlockName.get(block.blockID));
//		GameRegistry.registerBlock(block, itemClass);
//		LanguageRegistry.addName(block, title);
//		return block;
//	}
//
//	Item addItem(String title, Item item) {
//		int id = item.shiftedIndex - 256;
//		//System.out.printf("%s: Adding item %s id %s\n", modName, title, id);
//		item.setItemName(idToItemName.get(id));
//		LanguageRegistry.addName(item, title);
//		return item;
//	}
	
	//--------------- GUIs ----------------------------------------------------------

	public final static int guiSawbench = 1;
	
	@Override
	void registerContainers() {
		//System.out.printf("GregsBlocks.registerContainers\n");
		addContainer(guiSawbench, ContainerSawbench.class);
	}
	
	public void openGuiSawbench(World world, int x, int y, int z, EntityPlayer player) {
		//System.out.printf("GregsBlocks.openGuiSawbench\n");
		openGui(player, guiSawbench, world, x, y, z);
	}

}
